//+------------------------------------------------------------------+
//|                                         ConcreteObserverPull.mqh |
//|                                    2019-2020, dimitri pecheritsa |
//|                                                 792112@gmail.com |
//+------------------------------------------------------------------+
#include "ObserverPull.mqh"
#include "ConcreteSubjectPull.mqh"

class ConcreteObserver:public Observer
  {
public:
                     ConcreteObserver(ConcreteSubject& subject);

   void              Update(void);

protected:
   string            m_observer_state;
   ConcreteSubject*  m_subject;
  };


//+------------------------------------------------------------------+
//|                                                      constructor |
//+------------------------------------------------------------------+
ConcreteObserver::ConcreteObserver(ConcreteSubject& subject):
   m_subject(&subject)
  {
  }


//+------------------------------------------------------------------+
//|                                                           update |
//+------------------------------------------------------------------+
void ConcreteObserver::Update(void)
  {
   m_observer_state=m_subject.State();
   Print("observer ",&this," state set to: ",m_observer_state);
  }


//+------------------------------------------------------------------+
